﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TaskSlip
{
    public class TaskRepository
    {
        static List<Task> tasks;
        static int currentId = 0;
        
        public TaskRepository()
        {
            if (tasks == null)
            {
                tasks = new List<Task>();

                this.Add(new Task() { Name = "Buy Groceries", IsDone = true });
                this.Add(new Task() { Name = "Buy Fuel" });
            }
        }

        public void Add(Task task)
        {
            //Adding task, so increment our task id (faking database identity seed)
            task.Id = ++currentId;
            task.SortOrder = task.Id * 10;

            tasks.Add(task);
        }

        public IOrderedEnumerable<Task> FindAll()
        {
            return (tasks.OrderBy(t => t.SortOrder));
        }

        public bool Complete(int id)
        {
            bool isDone = false;

            if (id != 1)
            {
                isDone = true;
                tasks.Single(t => t.Id == id).IsDone = isDone;
            }

            return (isDone);
        }

        public bool Remove(int id)
        {
            try
            {
                tasks.Remove(tasks.Single(t => t.Id == id));

                return (true);
            }

            catch
            {
                return (false);
            }
        }

        public void ReOrder(int[] taskIds)
        {
            for (int i = 0, sort = 1; i < taskIds.Length; i++, sort++)
                tasks.Single(t => t.Id == taskIds[i]).SortOrder = sort * 10;
        }

    }
}
