﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Script.Serialization;

namespace TaskSlip
{
    /// <summary>
    /// Summary description for TaskService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]

    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    [System.Web.Script.Services.ScriptService] //We did
    public class TaskService : System.Web.Services.WebService
    {

        [WebMethod]
        public Task AddTask(string name)
        {
            var repo = new TaskRepository();
            Task task = new Task() { Name = name };
            repo.Add(task);
            return (task);
        }

        [WebMethod]
        public TaskCompleteResponse Complete(int id)
        {
            TaskRepository repo = new TaskRepository();
            repo.Complete(id);

            TaskCompleteResponse response = new TaskCompleteResponse();
            response.data = null; //no data to send back
            response.success = id != 1; //fake exception if try to complete task with id of 1

            if (response.success)
                response.message = "Completed";
            else
                response.message = "Unable to Complete";

            return (response);
        }

        [WebMethod]
        public bool Delete(int id)
        {
            TaskRepository repo = new TaskRepository();
            repo.Remove(id);

            return (true);
        }

        [WebMethod]
        public TaskCompleteResponse ReOrder(string[] taskIds)
        {
            TaskRepository repo = new TaskRepository();

            TaskCompleteResponse response = new TaskCompleteResponse();
            int[] tIds = new int[(taskIds.Length)];
            for(int i=0; i<taskIds.Length; i++)
            {
                if (!int.TryParse(taskIds[i].Substring(7), out tIds[i]))
                {
                    response.message = "Unable to Sort";
                    response.success = false;
                    response.data = repo.FindAll();
                    return (response);
                }
            }

            try
            {
                response.success = true;
                response.message = "Completed";
                response.data = null;

                //Simulate Random Error
                Random rand = new Random();
                if (rand.Next(3) == 1)
                    throw (new ApplicationException("Random Error Occurred"));
                else
                    repo.ReOrder(tIds);

            }
            catch(ApplicationException exc)
            {
                response.success = false;
                response.message = exc.Message;
                response.data = repo.FindAll();
            }

            return (response);
        }

    }
}
